unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, CheckLst, Buttons,jpeg, ActnList, ExtCtrls, AppEvnts ;

type

  TControlClass = class of TControl;

  proint=^promennaint;  //uchova promenne typu integer
  promennaint = record
                 int:integer;
                 jmeno:string;
                 dalsi:proint;
                 end;

  prostr=^promennastr;  //uchova promenne typu string
  promennastr = record
                 str:string;
                 jmeno:string;
                 dalsi:prostr;
                 end;

  Objekt=^objek;//slouzi k uchovani objektu
  objek   = record
                o:Tcontrol;
                jmeno:string;
                dalsi:Objekt;
                kam:string;
           end;

  skript=^skrip; //slouzi k ulozeni skriptu do pameti
  skrip = record
           pole:array[1..8192] of byte;
           pocet:integer;
           dalsi:skript;
           end;



  TForm1 = class(TForm)
    hodiny: TTimer;
    ActionList1: TActionList;
    Buttonclick: TAction;

    procedure FormCreate(Sender: TObject);
    procedure Ukoncit1Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure hodinyTimer(Sender: TObject);
    procedure ButtonClickExecute(Sender: TObject);


  private
    { Private declarations }
  public
    { Public declarations }

  P:PByteArray;  //slouzi k primemu vykresleni obrazku

  Obj:objekt; //dynamicka struktura v pameti na ukladani objektu
  pint:proint;//dynamicka struktura v pameti na ukladani promenych typu int
  pstr:prostr;//dynamicka struktura v pameti na ukladani promenych typu str
  chyba:boolean; //zda nastala chyba pri nacitani
  radek:integer; //udava aktualni radek v ini souboru
  pozadi:string; //plna cesta k souboru obrazku na pozadi
  pozadix,pozadiy:integer;//urcuje souradnice umisteni obrazku
  obrazek:Tbitmap;//slouzi k primemu vykresleni obrazku bmp
  obrazekjpg:tjpegimage;//bude slouzit k primemu vykresleni obrazku jpeg
  tlacitko:boolean;
  skr:skript;//ulozen skript v pameti
  skrpoz:integer; //pozice nacitaneho znaku v skriptu
  konec:boolean;
  end;

var
  Form1: TForm1;


implementation


{$R *.DFM}


//------------N-A-C-I-T-A-N-I--------------------------
procedure ead(var a:byte);
begin           //v teto verzi neuvazuju skripty delsi nez 8192 byte
if form1.skrpoz<=form1.skr^.pocet then begin
a:=form1.skr^.pole[form1.skrpoz];
form1.skrpoz:=form1.skrpoz+1;

end else form1.konec:=true;

end;



//--------------------C-H-Y-B-Y------------------------------
procedure chybiinstallini;
begin
if 1=MessageBox(0,PChar('Chyba v natn souboru install.ini-soubor neexistuje,nebo je umstn v neaktulnm aresi'),PChar('ERROR'), MB_OK) then form1.close;

end;

procedure chyba(radekk:integer);

var chybicka:string;
begin
str(radekk,chybicka);
if 1=MessageBox(0,PChar('Chyba v natn souboru install.ini na dku '+chybicka),PChar('ERROR'), MB_OK) then form1.close;

end;

//-----------P-O-M-O-C-N-E---P-R-O-C-E-D-U-R-Y-----------------
procedure komentar; //nacteni komentare
var a:byte;

begin
  repeat
   ead (a);
  until form1.konec or (form1.chyba) or (a=10);
  form1.radek:=form1.radek+1;
end;

procedure vykresli(co:string;x,y:integer);
begin

if co<>'' then begin
if co[length(co)]='p' then begin //obrazek je bmp
form1.obrazek.LoadFromFile(co);
form1.canvas.draw(x,y,form1.obrazek);
end else begin //obrazek je jpg


end;
end;
end;

procedure nacti;
var akt,pom:skript;
    f:file;
begin

assignfile(f,'install.ini');
try
reset(f,1);
except

on E: Exception do chybiinstallini;
end;

new(form1.skr);
form1.skr^.dalsi:=nil;

akt:=form1.skr;

repeat
  BlockRead(f, akt^.pole, SizeOf(akt^.pole), akt^.pocet);

  if akt^.pocet=8192 then begin
  new(pom);
  akt^.dalsi:=pom;
  akt:=pom;
  end;

  akt^.dalsi:=nil;
until akt^.pocet<8192;

end;

procedure skoc(jmeno:string);
var i:integer;
    akt:skript;
    jmn:string;

begin
akt:=form1.skr;
i:=0;

if jmeno<>'' then begin
while (i<>2048) and (jmeno<>jmn) do begin
jmn:='';
i:=i+1;
if (akt^.pole[i-1]=10) and (chr(akt^.pole[i])='^') then begin
i:=i+1;
repeat
jmn:=jmn+chr(akt^.pole[i]);
i:=i+1;
until (akt^.pole[i]=13) or (i>akt^.pocet);
end;
end;

if jmeno<>jmn then form1.chyba:=true else form1.skrpoz:=i+2;

end else form1.chyba:=true;
end;



procedure pridejint(jmeno:string;hodnota:integer);
var pom,akt:proint;

begin

 akt:=form1.pint;
 while ((akt^.dalsi<>nil) and (jmeno<>akt^.jmeno)) do begin
 akt:=akt^.dalsi;
 end;

 if akt^.jmeno=jmeno then akt^.int:=hodnota else
 begin
 new(pom);
 akt^.dalsi:=pom;
 pom^.dalsi:=nil;
 pom^.int:=hodnota;
 pom^.jmeno:=jmeno;
 end;

end;

procedure pridejstr(jmeno:string;hodnota:string);
var pom,akt:prostr;

begin

 akt:=form1.pstr;
 while ((akt^.dalsi<>nil) and (jmeno<>akt^.jmeno)) do begin
 akt:=akt^.dalsi;
 end;

 if akt^.jmeno=jmeno then akt^.str:=hodnota else
 begin
 new(pom);
 akt^.dalsi:=pom;
 pom^.dalsi:=nil;
 pom^.str:=hodnota;
 pom^.jmeno:=jmeno;
 end;

end;

procedure odeberint(jmeno:string);
var pom,akt:proint;

begin

 akt:=form1.pint^.dalsi;
 pom:=form1.pint;

 while ((akt^.dalsi<>nil) and (jmeno<>akt^.jmeno)) do begin
 akt:=akt^.dalsi;
 pom:=pom^.dalsi;
 end;

 if akt^.jmeno<>jmeno then form1.chyba:=true else
 begin
 pom^.dalsi:=akt^.dalsi;
 dispose(akt);
 end;

end;

procedure odeberstr(jmeno:string);
var pom,akt:prostr;

begin

 akt:=form1.pstr^.dalsi;
 pom:=form1.pstr;

 while ((akt^.dalsi<>nil) and (jmeno<>akt^.jmeno)) do begin
 akt:=akt^.dalsi;
 pom:=pom^.dalsi;
 end;

 if akt^.jmeno<>jmeno then form1.chyba:=true else
 begin
 pom^.dalsi:=akt^.dalsi;
 dispose(akt);
 end;

end;

procedure odeberobj(jmeno:string);
var pom,akt:Objekt;

begin

 akt:=form1.obj^.dalsi;
 pom:=form1.obj;

 while ((akt^.dalsi<>nil) and (jmeno<>akt^.jmeno)) do begin
 akt:=akt^.dalsi;
 pom:=pom^.dalsi;
 end;

 if akt^.jmeno<>jmeno then form1.chyba:=true else
 begin
 pom^.dalsi:=akt^.dalsi;
 akt^.o.free;
 dispose(akt);
 end;

end;

function zjistiint(jmeno:string):integer;
var akt:proint;
begin
akt:=form1.pint;
delete(jmeno,1,1);
while ((akt^.dalsi<>nil) and (jmeno<>akt^.jmeno)) do begin
 akt:=akt^.dalsi;
 end;

if akt^.jmeno<>jmeno then form1.chyba:=true else result:=akt^.int;
end;

function zjististr(jmeno:string):string;
var akt:prostr;
begin
akt:=form1.pstr;
delete(jmeno,1,1);
while ((akt^.dalsi<>nil) and (jmeno<>akt^.jmeno)) do begin
 akt:=akt^.dalsi;
 end;

if akt^.jmeno<>jmeno then form1.chyba:=true else result:=akt^.str;
end;


function nactipromenoui(koncovka:string;a:byte):integer;
var pom:string;
begin
pom:='';
while chr(a)<>koncovka do
begin
pom:=pom+chr(a);
ead(a);
end;
result:=zjistiint(pom);

end;

function nactipromenous(koncovka:string;a:byte):string;
var pom:string;
begin

pom:='';
while chr(a)<>koncovka do
begin
pom:=pom+chr(a);
ead(a);
end;
result:=zjististr(pom);

end;

//kopirovaci procedury

procedure copy1(jmeno1,jmeno2:string);//kopirovani nezkomprimovanych souboru
var fromf,tof:file;
    buf:array[1..2048] of byte;
    NumRead, NumWritten: Integer;

begin
  try

  assignfile(fromf,jmeno1);
  assignfile(tof,jmeno2);
  reset(fromf,1);
  rewrite(tof,1);

  repeat
  BlockRead(FromF, Buf, SizeOf(Buf), NumRead);
  BlockWrite(ToF, Buf, NumRead, NumWritten);
  until numread=0;


  except chyba(form1.radek);
  end;

end;


//---------------------------P1----------------------------------
procedure p1;
var a:byte;
    pom:integer;
begin

form1.borderstyle:=bssingle;
form1.windowstate:=wsnormal;

try
ead(a);
if chr(a)<>' ' then form1.chyba:=true;  //mezera = 32
ead(a);
if chr(a)<>'"' then form1.chyba:=true;  //uvozovky =34

pom:=0;

ead(a);
if chr(a)='^' then pom:=nactipromenoui(',',a) else
while chr(a)<>',' do
begin
pom:=pom*10+(a-48);
ead(a);
end;

if pom>0 then form1.width:=pom else
            begin form1.borderstyle:=bsnone;
                  form1.windowstate:=wsMaximized;
            end;
pom:=0;

ead(a);
if chr(a)='^' then pom:=nactipromenoui('"',a) else
while chr(a)<>'"' do
begin
pom:=pom*10+(a-48);
ead(a);
end;

if pom>0 then form1.height:=pom else
            begin form1.borderstyle:=bsnone;
                  form1.windowstate:=wsMaximized;
            end;

except
on E: Exception do chyba(form1.radek);
end;
end;

//---------------------------P2----------------------------------
procedure p2;
var a:byte;
    pom:integer;
begin


try
ead(a);
if chr(a)<>' ' then form1.chyba:=true;  //mezera = 32
ead(a);
if chr(a)<>'"' then form1.chyba:=true;  //uvozovky =34

pom:=0;

ead(a);
if chr(a)='^' then pom:=nactipromenoui(',',a) else
while chr(a)<>',' do
begin
pom:=pom*10+(a-48);
ead(a);
end;

if form1.windowstate=wsnormal then form1.left:=pom;

pom:=0;

ead(a);
if chr(a)='^' then pom:=nactipromenoui('"',a) else
while chr(a)<>'"' do
begin
pom:=pom*10+(a-48);
ead(a);
end;

if form1.windowstate=wsnormal then form1.top:=pom;

except
on E: Exception do chyba(form1.radek);
end;
end;

//---------------------------P3----------------------------------
procedure p3;
var a:byte;
    pom:integer;
begin

form1.pozadi:='';

try
ead(a);
if chr(a)<>' ' then form1.chyba:=true;  //mezera = 32
ead(a);
if chr(a)<>'"' then form1.chyba:=true;  //uvozovky =34

ead(a);
if chr(a)='^' then form1.pozadi:=nactipromenous(',',a) else
while chr(a)<>',' do
begin
form1.pozadi:=form1.pozadi+chr(a);
ead(a);
end;

pom:=0;
ead(a);
if chr(a)='^' then pom:=nactipromenoui(',',a) else
while chr(a)<>',' do
begin
pom:=pom*10+(a-48);
ead(a);
end;
form1.pozadix:=pom;

pom:=0;

ead(a);
if chr(a)='^' then pom:=nactipromenoui('"',a) else
while chr(a)<>'"' do
begin
pom:=pom*10+(a-48);
ead(a);
end;
form1.pozadiy:=pom;

except
on E: Exception do chyba(form1.radek);
end;

vykresli(form1.pozadi,form1.pozadix,form1.pozadiy);

end;

//---------------------------P4----------------------------------
procedure p4; //pridani promenne
var a:byte;
    typ,hodnotas,jmeno:string;
    hodnotai:integer;
    pom:integer;
    begin

try
ead(a);
if chr(a)<>' ' then form1.chyba:=true;  //mezera = 32
ead(a);
if chr(a)<>'"' then form1.chyba:=true;  //uvozovky =34

typ:='';
hodnotas:='';
hodnotai:=0;
jmeno:='';

ead(a);
if chr(a)='^' then typ:=nactipromenous(',',a) else
while chr(a)<>',' do
begin
typ:=typ+chr(a);
ead(a);
end;

ead(a);
if chr(a)='^' then jmeno:=nactipromenous(',',a) else
while chr(a)<>',' do
begin
jmeno:=jmeno+chr(a);
ead(a);
end;

hodnotai:=0;
if typ='int' then begin
ead(a);
if chr(a)='^' then hodnotai:=nactipromenoui('"',a) else
while chr(a)<>'"' do
begin
hodnotai:=hodnotai*10+(a-48);
ead(a);
end;
pridejint(jmeno,hodnotai);
               end;

if typ='str' then begin

ead(a);
if chr(a)='^' then hodnotas:=nactipromenous('"',a) else
while chr(a)<>'"' do
begin
hodnotas:=hodnotas+chr(a);
ead(a);
end;

pridejstr(jmeno,hodnotas);
                end;
if (typ<>'int') and (typ<>'str') then form1.chyba:=true;

except
on E: Exception do chyba(form1.radek);
end;


end;

//---------------------------P5----------------------------------
procedure p5;//odstraneni promenne
var a:byte;
    typ,jmeno:string;
begin

try
ead(a);
if chr(a)<>' ' then form1.chyba:=true;  //mezera = 32
ead(a);
if chr(a)<>'"' then form1.chyba:=true;  //uvozovky =34

typ:='';
jmeno:='';

ead(a);
if chr(a)='^' then typ:=nactipromenous(',',a) else
while chr(a)<>',' do
begin
typ:=typ+chr(a);
ead(a);
end;

ead(a);
if chr(a)='^' then jmeno:=nactipromenous('"',a) else
while chr(a)<>'"' do
begin
jmeno:=jmeno+chr(a);
ead(a);
end;


if typ='int' then begin

odeberint(jmeno);
               end;

if typ='str' then begin


odeberstr(jmeno);
                end;
if (typ<>'int') and (typ<>'str') then form1.chyba:=true;

except
on E: Exception do chyba(form1.radek);
end;


end;

//---------------------------P6----------------------------------
procedure p6;//odstraneni promenne
var a:byte;
    jmeno1,jmeno2:string;
begin

try
ead(a);
if chr(a)<>' ' then form1.chyba:=true;  //mezera = 32
ead(a);
if chr(a)<>'"' then form1.chyba:=true;  //uvozovky =34

jmeno1:='';
jmeno2:='';

ead(a);
if chr(a)='^' then jmeno1:=nactipromenous(',',a) else
while chr(a)<>',' do
begin
jmeno1:=jmeno1+chr(a);
ead(a);
end;

ead(a);
if chr(a)='^' then jmeno2:=nactipromenous('"',a) else
while chr(a)<>'"' do
begin
jmeno2:=jmeno2+chr(a);
ead(a);
end;

copy1(jmeno1,jmeno2);

except
on E: Exception do chyba(form1.radek);
end;


end;
//---------------------------------------------------------------
function CreateControl(ControlClass: TControlClass;
    const ControlName: string; X, Y, W, H: Integer;
    viditelnost:byte): TControl;

begin
  Result := ControlClass.Create(Form1);
  with Result do
  begin
    Parent := Form1;
    Name := ControlName;
    SetBounds(X, Y, W, H);
    if viditelnost=1 then Visible := True else visible:=false;
    end;
end;


//---------------------------O1----------------------------------

procedure o1;
var pm:byte;
    typ,viditelnost,a:byte;
    jmeno:string;
    sirka,vyska,zleva,odvrchu:integer;
    akt,pom:objekt;
    text:string;

 begin


try
ead(a);
if chr(a)<>' ' then form1.chyba:=true;  //mezera = 32
ead(a);
if chr(a)<>'"' then form1.chyba:=true;  //uvozovky =34

typ:=1;
viditelnost:=1;
sirka:=10;
vyska:=10;
zleva:=0;
odvrchu:=0;
jmeno:='';
text:='';

ead(a);
if chr(a)='^' then jmeno:=nactipromenous(',',a) else
while chr(a)<>',' do
begin
jmeno:=jmeno+chr(a);
ead(a);
end;


ead(a);
pm:=0;
if chr(a)='^' then pm:=nactipromenoui(',',a) else
while chr(a)<>',' do
begin
pm:=pm*10+(a-48);
ead(a);
end;
typ:=pm;

ead(a);
pm:=0;
if chr(a)='^' then pm:=nactipromenoui(',',a) else
while chr(a)<>',' do begin
pm:=pm*10+(a-48);
ead(a);
end;
sirka:=pm;
pm:=0;

ead(a);
if chr(a)='^' then pm:=nactipromenoui(',',a) else
while chr(a)<>',' do
begin
pm:=pm*10+(a-48);
ead(a);
end;
vyska:=pm;
pm:=0;

ead(a);
if chr(a)='^' then pm:=nactipromenoui(',',a) else
while chr(a)<>',' do
begin
pm:=pm*10+(a-48);
ead(a);
end;
zleva:=pm;
pm:=0;

ead(a);
if chr(a)='^' then pm:=nactipromenoui(',',a) else
while chr(a)<>',' do
begin
pm:=pm*10+(a-48);
ead(a);
end;
odvrchu:=pm;


ead(viditelnost);
viditelnost:=viditelnost-48;
ead(a);
if ','<>chr(a) then form1.chyba:=true;

ead(a);
if chr(a)='^' then text:=nactipromenous('"',a) else
while chr(a)<>'"' do
begin
text:=text+chr(a);
ead(a);
end;
 

except
on E: Exception do chyba(form1.radek);
end;

//ted se vyhleda zda objekt existuje, nebo ne

akt:=form1.obj;
 while ((akt^.dalsi<>nil) and (jmeno<>akt^.jmeno)) do begin
 akt:=akt^.dalsi;
 end;

 if akt^.jmeno<>jmeno then
 begin
 new(pom);
 akt^.dalsi:=pom;
 pom^.dalsi:=nil;
 pom^.jmeno:=jmeno;

 case typ of
  1:begin pom^.kam:='';
  pom^.o:=CreateControl(Tbutton,Jmeno,sirka,vyska,zleva,odvrchu,viditelnost);//+text
  end;
  2:begin pom^.kam:='';
  pom^.o:=CreateControl(Tedit,Jmeno,sirka,vyska,zleva,odvrchu,viditelnost);//+text
  end;
  3:;
 end;

 pom^.o.SetTextBuf(pchar(text));

 end else begin


 akt^.o.width:=zleva;//lalala
 akt^.o.height:=odvrchu;
 akt^.o.top:=vyska;
 akt^.o.left:=sirka;
 if viditelnost=1 then akt^.o.visible:=true else akt^.o.visible:=false;
 akt^.o.SetTextBuf(pchar(text));

 end;




end;

//---------------------------O2----------------------------------
procedure o2;//odstraneni objektu
var a:byte;
    jmeno:string;
begin

try
ead(a);
if chr(a)<>' ' then form1.chyba:=true;  //mezera = 32
ead(a);
if chr(a)<>'"' then form1.chyba:=true;  //uvozovky =34

jmeno:='';
ead(a);
if chr(a)='^' then jmeno:=nactipromenous('"',a) else
while chr(a)<>'"' do
begin
jmeno:=jmeno+chr(a);
ead(a);
end;

odeberobj(jmeno);

except
on E: Exception do chyba(form1.radek);
end;


end;

//-----------------------------A1----------------------------
procedure a1;
var jmeno,jmeno2:string;
    akt:objekt;
    a:byte;
    textik,jmenoobj:string;
    buffer:pchar;
    Pom:TAction;
    begin

try
ead(a);
if chr(a)<>' ' then form1.chyba:=true;  //mezera = 32
ead(a);
if chr(a)<>'"' then form1.chyba:=true;  //uvozovky =34


jmeno:='';
ead(a);
if chr(a)='^' then jmeno:=nactipromenous(',',a) else
while chr(a)<>',' do
begin
jmeno:=jmeno+chr(a);
ead(a);
end;

jmeno2:='';
ead(a);
if chr(a)='^' then jmeno2:=nactipromenous('"',a) else
while chr(a)<>'"' do
begin
jmeno2:=jmeno2+chr(a);
ead(a);
end;


 akt:=form1.obj^.dalsi;

 while ((akt^.dalsi<>nil) and (jmeno<>akt^.jmeno)) do begin
 akt:=akt^.dalsi;
 end;

 if akt^.jmeno<>jmeno then form1.chyba:=true else
 begin


 if akt^.o.action=nil then begin//uz byla nejaka akce prirazena
 akt^.o.GetTextBuf(buffer,akt^.o.gettextlen+1);
 textik:=strpas(buffer);
 jmenoobj:=akt^.o.name;

pom:=Taction.create(form1);

pom.OnExecute:=form1.Buttonclick.OnExecute;

 akt^.o.Action:=pom;
 akt^.o.Action.name:='x'+jmeno;
 akt^.kam:=jmeno2;

 akt^.o.name:=jmenoobj;
 akt^.o.settextbuf(buffer);

 end else akt^.kam:=jmeno2;

 end;


except
on E: Exception do chyba(form1.radek);
end;

end;


//-----------------------------A2----------------------------

procedure a2;
var jmeno,jmeno1,jmeno2:string;
    a:byte;
    begin

try
ead(a);
if chr(a)<>' ' then form1.chyba:=true;  //mezera = 32
ead(a);
if chr(a)<>'"' then form1.chyba:=true;  //uvozovky =34


jmeno:='';
ead(a);
if chr(a)='^' then jmeno:=nactipromenous(',',a) else
while chr(a)<>',' do
begin
jmeno:=jmeno+chr(a);
ead(a);
end;

jmeno1:='';
ead(a);
if chr(a)='^' then jmeno1:=nactipromenous(',',a) else
while chr(a)<>',' do
begin
jmeno1:=jmeno1+chr(a);
ead(a);
end;


jmeno2:='';
ead(a);
if chr(a)='^' then jmeno2:=nactipromenous('"',a) else
while chr(a)<>'"' do
begin
jmeno2:=jmeno2+chr(a);
ead(a);
end;

pridejstr(jmeno,jmeno1+jmeno2);


except
on E: Exception do chyba(form1.radek);
end;

end;

//-------------------------A2--A3--A4----------------------

procedure a3(op:byte);
var jmeno:string;
    cislo,cislo2,vysl:integer;
    a:byte;
    begin
try
ead(a);
if chr(a)<>' ' then form1.chyba:=true;  //mezera = 32
ead(a);
if chr(a)<>'"' then form1.chyba:=true;  //uvozovky =34


jmeno:='';
ead(a);
if chr(a)='^' then jmeno:=nactipromenous(',',a) else
while chr(a)<>',' do
begin
jmeno:=jmeno+chr(a);
ead(a);
end;


cislo:=0;
ead(a);
if chr(a)='^' then cislo:=nactipromenoui(',',a) else
while chr(a)<>',' do
begin
cislo:=cislo*10+(a-48);
ead(a);
end;

cislo2:=0;
ead(a);
if chr(a)='^' then cislo2:=nactipromenoui('"',a) else
while chr(a)<>'"' do
begin
cislo2:=cislo2*10+(a-48);
ead(a);
end;


case op of
1:vysl:=cislo+cislo2;
2:vysl:=cislo*cislo2;
3:vysl:=cislo-cislo2;

end;

pridejint(jmeno,vysl);

except
on E: Exception do chyba(form1.radek);
end;

end;

//-----------------------------A6-----------------------------
procedure a6;
var jmeno,jmeno2:string;
    buffer:pchar;
    a:byte;
    akt:objekt;
    begin
try
ead(a);
if chr(a)<>' ' then form1.chyba:=true;  //mezera = 32
ead(a);
if chr(a)<>'"' then form1.chyba:=true;  //uvozovky =34


jmeno:='';
ead(a);
if chr(a)='^' then jmeno:=nactipromenous(',',a) else
while chr(a)<>',' do
begin
jmeno:=jmeno+chr(a);
ead(a);
end;

jmeno2:='';
ead(a);
if chr(a)='^' then jmeno2:=nactipromenous('"',a) else
while chr(a)<>'"' do
begin
jmeno2:=jmeno2+chr(a);
ead(a);
end;

 akt:=form1.obj^.dalsi;

 while ((akt^.dalsi<>nil) and (jmeno<>akt^.jmeno)) do begin
 akt:=akt^.dalsi;
 end;

 if akt^.jmeno<>jmeno then form1.chyba:=true else
 begin

 akt^.o.GetTextBuf(buffer,akt^.o.gettextlen+1);
 pridejstr(jmeno2,strpas(buffer));

 // Size := Edit1.GetTextLen;       {Get length of string in Edit1}
 // Inc(Size);                      {Add room for null character}
 // GetMem(Buffer, Size);           {Creates Buffer dynamic variable}
 // Edit1.GetTextBuf(Buffer,Size);  {Puts Edit1.Text into Buffer}
 // Edit2.Text := StrPas(Buffer);   {Converts Buffer to a Pascal-style string}
 // FreeMem(Buffer, Size);{Frees memory allocated to Buffer}


 end;


except
on E: Exception do chyba(form1.radek);
end;

end;

//--------------------S-K-O-K--------------------------------
procedure skok;
var jmeno:string;
    a:byte;
    begin
try
ead(a);
if chr(a)<>' ' then form1.chyba:=true;  //mezera = 32
ead(a);
if chr(a)<>'"' then form1.chyba:=true;  //uvozovky =34


jmeno:='';
ead(a);
if chr(a)='^' then jmeno:=nactipromenous('"',a) else
while chr(a)<>'"' do
begin
jmeno:=jmeno+chr(a);
ead(a);
end;

skoc(jmeno);

except
on E: Exception do chyba(form1.radek);
end;

end;

//------------------P-O-D-M-I-N-K-A-------------------------
procedure podminkas;
var prvni,druhy,kame,kamt:string;
    a:byte;
    begin
try
ead(a);
if chr(a)<>' ' then form1.chyba:=true;  //mezera = 32
ead(a);
if chr(a)<>'"' then form1.chyba:=true;  //uvozovky =34


prvni:='';
ead(a);
if chr(a)='^' then prvni:=nactipromenous(',',a) else
while chr(a)<>',' do
begin
prvni:=prvni+chr(a);
ead(a);
end;

druhy:='';
ead(a);
if chr(a)='^' then druhy:=nactipromenous(',',a) else
while chr(a)<>',' do
begin
druhy:=druhy+chr(a);
ead(a);
end;

kamt:='';
ead(a);
if chr(a)='^' then kamt:=nactipromenous(',',a) else
while chr(a)<>',' do
begin
kamt:=kamt+chr(a);
ead(a);
end;

kame:='';
ead(a);
if chr(a)='^' then kame:=nactipromenous('"',a) else
while chr(a)<>'"' do
begin
kame:=kame+chr(a);
ead(a);
end;

if prvni=druhy then skoc(kamt) else skoc(kame);

except
on E: Exception do chyba(form1.radek);
end;

end;



//---------------R-O-Z-D-E-L-E-N-I--D-O--S-O-U-C-A-S-T-I-----

procedure prikazy;
var a:byte;

begin

try

ead(a);
if chr(a)<>' ' then form1.chyba:=true;
ead(a);

except
on E: Exception do chyba(form1.radek);
end;

case chr(a) of
'1':p1;
'2':p2;
'3':p3;
'4':p4;
'5':p5;
'6':p6;

end;// else form1.chyba:=true;

end;

procedure akce;  //dotazy
var a:byte;

begin

try

ead(a);
if chr(a)<>' ' then form1.chyba:=true;
ead(a);

except
on E: Exception do chyba(form1.radek);
end;

case chr(a) of
'1':a1;
'2':a2;
'3':a3(1);
'4':a3(2);
'5':a3(3);
'6':a6;
end;// else form1.chyba:=true;

end;

procedure objekty;  //objekty
var a:byte;

begin

try

ead(a);
if chr(a)<>' ' then form1.chyba:=true;
ead(a);

except
on E: Exception do chyba(form1.radek);
end;

case chr(a) of
'1':o1;
'2':o2;


end;// else form1.chyba:=true;

end;


//--------------------H-L-A-V-N-I----------------------------
procedure hlavni;

var a:byte; //poradi bytu v nacitanem textu
begin

while (not form1.konec) and (not form1.chyba) and(not form1.tlacitko) do begin //a tohle jeste asi budu opakovat
                        //dokud neprijde udalost na neco cekajici
ead(a);
case chr(a) of

'~':komentar;
'p':prikazy;
'a':akce;
'o':objekty;
'j':skok;
'i':podminkas;
#13:ead(a);
's': form1.tlacitko:=true;
'^':komentar;
't':form1.close;
end;


if form1.chyba then chyba(form1.radek);
if a=10 then form1.radek:=form1.radek+1;

end;//while

end;

//nastaveni globalnich promennych na initialni hodnoty
procedure TForm1.FormCreate(Sender: TObject);
begin
left:=0;
top:=0;
pozadix:=0;
pozadiy:=0;
pozadi:='';
new(pint);
pint^.dalsi:=nil;
pint^.jmeno:='Prvni string, no nepredpokladam, ze by se promenna jmenovala prave takto';
new(pstr);
pstr^.dalsi:=nil;
pstr^.jmeno:='Prvni string, no nepredpokladam, ze by se promenna jmenovala prave takto';
new(Obj);
obj^.dalsi:=nil;
obj^.jmeno:='Prvni string, no nepredpokladam, ze by se promenna jmenovala prave takto';
obj^.kam:='';

position:=podefault;
obrazek:=Tbitmap.create;
konec:=false;
tlacitko:=false;
chyba:=false;
radek:=1;
skrpoz:=1;
nacti;
end;

procedure TForm1.Ukoncit1Click(Sender: TObject);
begin
form1.close;
end;


procedure TForm1.FormPaint(Sender: TObject);
begin
vykresli(pozadi,pozadix,pozadiy);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
obrazek.free;
//close(f);
end;

procedure TForm1.hodinyTimer(Sender: TObject);
begin
hlavni;
end;

procedure TForm1.ButtonClickExecute(Sender: TObject);//sender je taction
var akt:objekt;
    jmeno:string;
    pom:taction;
begin

form1.tlacitko:=false;
pom:=(sender as Taction);
jmeno:=pom.GetNamePath;
delete(jmeno,1,1);
akt:=form1.obj;
while (akt^.dalsi<>nil) and (jmeno<>akt^.jmeno)  do begin
akt:=akt^.dalsi;

end;

skoc(akt^.kam);

end;

end.
